﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Drawing;
using SharpShell.SharpIconOverlayHandler;
using SharpShell.Interop;
using System.Runtime.InteropServices;
using System.IO;

// See: http://www.codeproject.com/Articles/545781/NET-Shell-Extensions-Shell-Icon-Overlay-Handlers

[ComVisible(true)]
public class EmptyFolderOverlayHandler : SharpIconOverlayHandler {

  protected override Icon GetOverlayIcon() {
    return EmptyFolderOverlay.Properties.Resources.OverlayIcon;
  }

  protected override int GetPriority() {
    return 10;
  }

  protected override bool CanShowOverlay(string path, SharpShell.Interop.FILE_ATTRIBUTE attributes) {
    try {
      if ((attributes & FILE_ATTRIBUTE.FILE_ATTRIBUTE_DIRECTORY) != 0) {
        DateTime timeLimit = DateTime.Now.AddMilliseconds(1000);  // Abort traversal after 1s.
        return pathIsEmpty(path, timeLimit);
      }
      return false;
    }
    catch (Exception) {
      return false;
    }
  }

  protected bool pathIsEmpty(string path, DateTime timeLimit) {
    foreach (string f in Directory.EnumerateFiles(path)) {
      if (!f.EndsWith("Thumbs.db")) {
        // Found a real file, so not empty.
        return false;
      }
    }
    foreach (string d in Directory.EnumerateDirectories(path)) {
      if ((DateTime.Now > timeLimit) || !pathIsEmpty(d, timeLimit))  {
        return false;
      }
    }
    return true;
  }
}
